package LexicalAnalyser;

/**
 * 
 * @author Matthieu Biache
 * @version 1.0
 * <br>
 * AbstractToken
 * Classe représentant un élement de la liste obtenu suite à l'analyse lexicale
 * Une instance de la classe AbstractToken étant définie par son type uniquement (TokenType type)
 * @see Lexer
 * @see TokenType
 *
 */
public class AbstractToken {
	public TokenType type;
	
	public AbstractToken(TokenType _type) {
		type=_type;
	}
	
	public TokenType getTokenType() {
		return type;
	}
	
	public String toString() {
		return "("+type.name()+")";
	}

	public String toJsonString() {
		return type.name();
	}

	public String toRawString() {
		return type.name();
	}
}
