package LexicalAnalyser;

import SyntacticalAnalyser.Syntaxer;
import SyntacticalAnalyser.TokenTree;

/**
 * 
 * @author Matthieu Biache
 * @version 1.0
 * <br>
 * Token
 * Classe représentant un noeud de l'arbre syntaxique abstrait
 * Une instance de la classe Token étant définie par un couple (TokenType type, String data)
 * @see Syntaxer
 * @see TokenTree
 * @see TokenType
 *
 */
public class Token extends AbstractToken {
	public String data;
	
	public Token(TokenType _type, String _data) {
		super(_type);
		data=_data;
	}
	
	@Override
	public String toString() {
		return "("+type.name()+" : \""+data+"\")";
	}
	
	@Override
	public String toJsonString() {
		switch(this.getTokenType()) {
		case ID:
		case NUMBER:
			return type.name()+" : "+data;
		default:
			return data;
		}
	}
	
	@Override
	public String toRawString() {
		return data;
	}

	public String getData() {
		return data;
	}

	public boolean isNode(TokenType tokenType) {
		return getTokenType().equals(tokenType);
	}
}
