package Main;
import java.io.FileNotFoundException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;

import LexicalAnalyser.Lexer;
import LexicalAnalyser.Token;
import SyntacticalAnalyser.Syntaxer;
import SyntacticalAnalyser.TokenTree;
import Tools.Debug;
import Tools.ErrorQueryInput;
import Translator.Translator;

public class Main {
	public static void main(String args[]) throws FileNotFoundException, UnsupportedEncodingException{
		Debug.getInstance().lancerDebug();
		
		String input = "DEFINEQRELATIVEASC MOST AS (0,1) defineasc high as (0.5,2) defineasc recent as (2013,2016) defineasc strong as (0,1) in match (p:paper)-[:published]->(j:journal)-[:impactfactor]->(i:impactfactor), (j:journal)-[:dom]->(d), (x:author)-[[authorof| ST IS strong]]->(p) where p.year is recent with x having most(p) ARE (i.value is high AND d.name='Database')";
   
		//String input = ErrorQueryInput.get(101);
		//String input = WellFormedQueryInput.get(13);
		
		ArrayList<Token> tokens = null;
		//Suppression des commentaires
		//input = input.trim().replaceAll("//.*\n"," \n");
		//input = input.trim().replaceAll("//.*$","");
		
		//Suppression des doubles espaces
		//input = input.trim().replaceAll(" +"," ");
		
		//Analyse Lexicale	
		System.out.println("\n***Begin LA***");
		tokens = Lexer.tokenize(input);
		
		for (int i=0; i< tokens.size();i++){
			System.out.println(tokens.get(i));
		}
		

		
		System.out.println("***End LA***");
		
		//Analyse Syntaxique
		System.out.println("\n***Begin SA***");
	 TokenTree ats = Syntaxer.generateATS(tokens);
		System.out.println("tree"+ ats.toString(tokens.size()));

		System.out.println("***End SA***");
		
		//System.out.println(ats.toString(0));
		
		System.out.println("\n***Begin T***");
		String output = Translator.simpleTranslate(ats);
		System.out.println("***End T***");
		System.out.println(output);
	}
}
