package Tools;

/**
 * 
 * @author Matthieu Biache
 * @version 1.0
 * <br>
 * Debug
 * Classe permettant un suivi de l'exécution de méthodes sur la sortie System.out
 *
 */
public class Debug {
	private static boolean estActif;
	private static int compteur;
	
	private Debug() {
		estActif=false;
		compteur=0;
	}
	
	private static class Holder {
		private final static Debug instance = new Debug();
	}
	
	public static Debug getInstance() {	
		return Holder.instance;
	}
	
	public synchronized static void afficherMessage(String message) {
		if(message !=null & estActif) {
			System.out.println(message);
		}
	}
	
	public synchronized void lancerDebug() {
		estActif=true;
	}
	
	public synchronized static void stopDebug() {
		estActif=false;
	}

	public synchronized static void afficheMethod(Class<?> c) {
		if(c !=null) {
			StackTraceElement[] t = new Throwable().getStackTrace();
			String s = "[INFO] "+compteur+" | "+t[2].getMethodName()+" -> "+t[1].getMethodName()+"\t";
			afficherMessage(s);
			compteur++;
		}
		
	}
}
