package Tools;

import SyntacticalAnalyser.Syntaxer;
import SyntacticalAnalyser.SyntaxException;

/**
 * 
 * @author Matthieu Biache
 * @version 1.0
 * <br>
 * ErrorQueryInput
 * Classe fournissant différentes requêtes FUDGE erronées permettant la génération d'une erreur de Syntaxe lors de l'analyse syntaxique
 * @see Syntaxer
 * @see SyntaxException
 *
 */
public class ErrorQueryInput {
	public static String get(int i) {
		String input;
		
		switch (i) {
			case 0:input="";break;
		
			//Fuzzy Define Block
			case 101:input="DEFINEASC small AS (1,2)";break;
			case 102:input="DEFINEASC small AS (1,2) IN";break;
			
			//Define Block
			case 111:input="";break; //Not possible in current state
			case 112:input="DEFINE";break;
			case 113:input="DEFINE small";break;
			case 114:input="DEFINE small AS";break;
			case 115:input="DEFINE small AS (";break;
			case 116:input="DEFINE small AS (2";break;
			case 117:input="DEFINE small AS (2,";break;
			case 118:input="DEFINE small AS (2,3";break;
			case 119:input="DEFINE small AS (2,3,";break;
			case 120:input="DEFINE small AS (2,3,4";break;
			case 121:input="DEFINE small AS (2,3,4,";break;
			case 122:input="DEFINE small AS (2,3,4,5";break;
			
			//Define Asc Or Desc Block
			case 131:input="";break; //Not possible in current state
			case 132:input="DEFINEASC";break;
			case 133:input="DEFINEASC small";break;
			case 134:input="DEFINEASC small AS ";break;
			case 135:input="DEFINEASC small AS (";break;
			case 136:input="DEFINEASC small AS (1";break;
			case 137:input="DEFINEASC small AS (1,";break;
			case 138:input="DEFINEASC small AS (1,2";break;
			
			//Fuzzy Relationship Block
			case 201:input="";break; //Not possible in current state
			case 202:input="c [[";break;
			case 203:input="c [[small|";break;
			case 204:input="c [[small|Length";break;
			case 205:input="c [[small|Length IS";break;
			case 206:input="c [[small|Length IS big";break;
			case 207:input="c [[small|Length IS big]]";break;
			
			//Expression
			case 210:input="";break; //TODO
			case 211:input="c [[big+";break;
			case 212:input="";break; //TODO
			case 213:input="";break; //TODO
			case 214:input="c [[(";break;
			case 215:input="";break; //TODO
			case 216:input="c [[big.";break;
			case 217:input="";break; //TODO
			case 218:input="";break; //TODO
			case 219:input="";break; //TODO
			case 220:input="c [[(big+)";break;
			case 221:input="c [[((big*)*";break;
			case 222:input="c [[((big+)+";break;
			
			//Fuzzy Conditions Block
			case 301:input="";break;//*
			case 302:input="c IS";break;
			case 303:input="c IS big";break;
			default:input="";break;
		}
		System.out.println(input);
		return input;
	}
}
