package Tools;

import SyntacticalAnalyser.Syntaxer;
import SyntacticalAnalyser.SyntaxException;

/**
 * 
 * @author Matthieu Biache
 * @version 1.0
 * <br>
 * WellFormedQueryInput
 * Classe fournissant différentes requêtes FUDGE bien formées permettant la génération d'un arbre syntaxique abstrait bien formé lors de l'analyse syntaxique
 * @see Syntaxer
 * @see SyntaxException
 *
 */
public class WellFormedQueryInput {
	public static String get(int i) {
		String input;
		switch (i) {
			case 1:input="DEFINEASC small AS (1,2) IN c";break;
			case 2:input="DEFINEDESC small AS (1,2) IN c";break;
			case 3:input="DEFINE small AS (1,2,3,4) IN c";break;
			case 4:input="DEFINEASC small AS (1,2) DEFINEDESC big AS (3,4) IN c";break;
		
			case 5:input="c [[small|Length IS big]] c";break;
			case 6:input="c [[small|Length IS big]] c [[big|ST IS small]] c";break;
			
			case 7:input="c IS big c";break;
			case 8:input="c IS big c IS small c";break;
			
			case 9:input="DEFINEASC small AS (1,2) IN c [[small|Length IS big]] c IS big c";break;
			case 10:input="DEFINEASC small AS (1,2) IN c IS big c";break;
			case 11:input="c [[small|Length IS big]] c IS big c";break;
			case 12:input="DEFINEASC small AS (1,2) IN c IS big c";break;
			
			case 13:input="DEFINEASC small AS (1,2) DEFINEDESC big AS (3,4) IN c [[small|Length IS big]] c [[big|ST IS small]] c IS big c IS small c";break;
			
			
			
			default:input="";break;
		}
		System.out.println(input);
		return input;
	}
}
