package Translator;

import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author Xuyang Zhang et Mohamed Amine Daouma
 * Translator from fudge langage to cypher langage
 */
@Deprecated
public class Traducteur {
	/*Dictionary of trapezoidal functions*/
	private Map<String,TrapezoidalFunction> trapezList = new HashMap<String, TrapezoidalFunction>();
	
	public Traducteur() {
		super();
	}
	
	/*Function that enables translating from a fudge query to a cypher one
	 * @param mot FUDGE query
	 * @return result CYPHER query
	 * */
	public String fudge_transcriptor_module(String mot) {
		/* replace \n by space*/
		mot = mot.replaceAll("\n", " ");
		
		/* remove spaces in the beginning and in the end of the FUDGE query*/
		mot = mot.replaceAll("(^\\s{1,})|(\\s{1,}$)", "");
		
		/*add \n before each keyword */
		mot = mot.replaceAll("DEFINEDESC|DEFINEASC|DEFINE|IN|MATCH|WHERE|RETURN|return|defineasc|definedesc|define|in|match|where", "\n$0");
		System.out.println(mot);
		String result = "";
		
		/*List of nodes in fudge query*/
		LinkedList<String> nodeList = new LinkedList<String>();
		
		/*List of cypher queries in which Length is present
		 * example: if we have two lines and each one of them contains "Length",
		 * "withReduceList" will contain 2 elements (String) representing each one of them
		 * the translation of the fudge query which contains "Length" word */
		LinkedList<String> withReduceList = new LinkedList<String>();
		
		/*The conditions of the query : the condition selected after the keyword WHERE*/
		LinkedList<String> conditionList = new LinkedList<String>();
		
		/* Map to define the fuzzy keys (calc_fuzzy_length_p1_short) 
		 * and the corresponding values (length_au1_au2_p1)*/
		Map<String, String> fuzzyDist=new HashMap<String, String>();
		
		String lengthStr="";
		String abcissa="";
		
		/*When "Length" is occured in the fudge query, we create a variable which 
		 * holds the relationship between the 2 nodes in question
		 * this list's name is p */
		LinkedList<String> p = new LinkedList<String>();
		for(int i=1;i<10;i++){
			p.add("p"+i);
		}
		/* 1- Split fudge query in different lines/rows thanks to '\n'
		 * 2- Split each row with "space" in order to detect the first string (ex:DEFINEASC)
		 * 3- Identify the first keyword and call the corresponding methods
		 * */
		for (String retval : mot.split("\n")) {
			System.out.println(retval);
			String[] motLigne = retval.split(" ");
			switch (motLigne[0].toUpperCase()){
			case "DEFINEASC":
				motLigne[3] = motLigne[3].replaceAll("\\(|\\)", "");
				String[] seuil = motLigne[3].split(",");
				final TrapezoidalFunction trapez = new IncreasingTrapezoidalFunction(motLigne[1], Double.parseDouble(seuil[0]),Double.parseDouble(seuil[1]));
				trapezList.put(motLigne[1],trapez); break;
			case "DEFINEDESC":
				motLigne[3] = motLigne[3].replaceAll("\\(|\\)", "");
				String[] seuil1 = motLigne[3].split(",");
				final TrapezoidalFunction trapez1 = new DecreasingTrapezoidalFunction(motLigne[1], Double.parseDouble(seuil1[0]),Double.parseDouble(seuil1[1]));
				trapezList.put(motLigne[1],trapez1);break;
			case "DEFINE":
				motLigne[3] = motLigne[3].replaceAll("\\(|\\)", "");
				String[] seuil2 = motLigne[3].split(",");
				final TrapezoidalFunction trapez2 = new TrapezoidalFunction(motLigne[1], Double.parseDouble(seuil2[0]),Double.parseDouble(seuil2[1]),Double.parseDouble(seuil2[2]),Double.parseDouble(seuil2[3]));
				trapezList.put(motLigne[1],trapez2);
				break;
			case "IN":
				break;
			case "MATCH":
				retval = retval.replaceAll(",", ",\n");
				for (String ret : retval.split("\n")) {
					lengthStr = addNode(ret,nodeList);
					String[] motL = ret.split(" ");
					LinkedList<Integer> index = new LinkedList<Integer>();
					boolean trouve = false;
					for (int i = 0; i < motL.length; i++) {
						if (motL[i].equals("is") || motL[i].equals("IS")) {
							trouve = true;
							index.add(i);
						}
					}
					if (trouve == true) {
						for (int j = 0; j < index.size(); j++) {
							int indexOfIs = index.get(j);
							String withReduce="";
							try {
								//replace "| Length..." by "]"
								motL[indexOfIs] = "";
								abcissa = lengthStr+"_"+p.getFirst();
								if(motL[indexOfIs-1].equals("Length")){
									ret = ret.replaceAll("\\| Length .{1,}]","]");
									withReduce= "\n"+ "WITH DISTINCT REDUCE(weight=0, edge IN relationships(p1)| weight + 1/edge.fdegree) AS "+abcissa ;
									
								}
								else if(motL[indexOfIs-1].equals("ST")){
									ret = ret.replaceAll("\\| ST .{1,}]","]" );
									withReduce= "\n"+"WITH DISTINCT REDUCE (min =1.0, edge IN relationships(p1)| case when edge.fdegree<min then edge.fdegree else min end) AS "+lengthStr+"_"+p.getFirst();
									//withReduce = "\n"+"FOREACH (edge in RELATIONSHIPS(p1) : SET minim =0.5, case when edge.fdegree< minim then edge.fdegree else minim end) AS"+lengthStr+"_"+p.getFirst();
								}
								
								result += "\n " + p.getFirst()+" ="+ ret;
								//add "WITH REDUCE ..."

								Iterator<String> ite = nodeList.iterator();
								while (ite.hasNext()) {
									String s = ite.next();
									withReduce += "," + s + " AS " + s;
								}
								withReduceList.add(withReduce);
								//add conditions in WHERE
								Iterator<TrapezoidalFunction> itr = trapezList.values().iterator();
								String cdt = "";
								while (itr.hasNext()) {
									TrapezoidalFunction itrTrape = (TrapezoidalFunction) itr.next();
									if (motL[indexOfIs + 1].equals(itrTrape.getName())) {
										cdt = itrTrape.translator_query_test(motL[indexOfIs - 1],abcissa);

									}
								}
								String condition = " AND " + lengthStr+"_"+p.getFirst()+ cdt;
								conditionList.add(condition);
								fuzzyDist.put("calc_fuzzy_length_"+p.getFirst()+"_"+motL[indexOfIs + 1], lengthStr+"_"+p.getFirst());
								p.removeFirst();
		
							} 
							
							catch (NoLowerBound e) {
								e.printStackTrace();
							} catch (NoUpperBound e) {
								e.printStackTrace();
							}
						}
					}else {
						result += "\n" + ret;
					}
				}				
				break;
			case "WHERE":
				Iterator<String> ite=withReduceList.iterator();
				while(ite.hasNext()){
					result+=ite.next();
				}
				
				String[] motL = retval.split(" ");
				LinkedList<Integer> index = new LinkedList<Integer>();
				boolean trouve = false;
				for (int i = 0; i < motL.length; i++) {
					if (motL[i].equals("is") || motL[i].equals("IS")) {
						trouve = true;
						index.add(i);
					}
				}
				if (trouve == true) {
					String resultTmp="";
					for (int j = 0; j < index.size(); j++) {
						int indexOfIs = index.get(j);
						try {
							motL[indexOfIs] = "";
							String attri="";
							if(motL[indexOfIs - 1].contains(".")){
								attri=motL[indexOfIs - 1].replaceAll("(.*)\\.(.*)", "$1_$2");
							}
							fuzzyDist.put("calc_fuzzy_"+attri+"_"+motL[indexOfIs + 1], motL[indexOfIs - 1]);
							//Translator from fudge langage to cypher langage
							Iterator<TrapezoidalFunction> itr = trapezList.values().iterator();
							while (itr.hasNext()) {
								TrapezoidalFunction itrTrape = (TrapezoidalFunction) itr.next();
								if (motL[indexOfIs + 1].equals(itrTrape.getName())) {
									motL[indexOfIs + 1] = itrTrape.translator_query_test(motL[indexOfIs - 1],abcissa);
								}
							}
							resultTmp = "\n";
							for (int m = 0; m < motL.length; m++) {
								resultTmp += motL[m] + " ";
							}								
						} catch (NoLowerBound e) {
							e.printStackTrace();
						} catch (NoUpperBound e) {
							e.printStackTrace();
						}
					}
					result+=resultTmp;

				} else {
					result += "\n" + retval;
				}
				
				break;
			default: break;
			
			}
		}
		Iterator<String> iteCondition=conditionList.iterator();
		while(iteCondition.hasNext()){
			result+=iteCondition.next();
		}
		result+="\nRETURN DISTINCT ";
		Iterator<String> iteNode=nodeList.iterator();
		while(iteNode.hasNext()){
			result+=iteNode.next()+",";
		}
		Set<Entry<String, String>> entries = fuzzyDist.entrySet();
		Iterator<Entry<String, String>> iter = entries.iterator();
		while(iter.hasNext()) {
			Entry<String, String> entry = iter.next();
			result+=entry.getValue()+" AS "+entry.getKey()+",";
			
		}
		result=result.substring(0,result.length()-1);
		//result+="\n"+"Order by satisfaction_degree";
		//System.out.println("le result est : "+result);
		
		return result;
	}

	public boolean dejaDansListe(LinkedList<String> l, String e) {
		boolean existe = false;
		Iterator<String> ite = l.iterator();
		while (ite.hasNext()) {
			if (e.equals(ite.next())) {
				existe = true;
			}
		}
		return existe;
	}
	
	/*This method adds a node in nodeList 
	 * @param fudge query +  nodeList
	 * @return a string*/
	public String addNode(String ret, LinkedList<String> nodeList) {
		String lengthStr="";
		String node="";
		for(int i=0;i<ret.length();i++){
			if(ret.charAt(i)=='('){
				node="1";
			}else if(ret.charAt(i)==')'){
				if(node.contains(":")){
					String[] tab=node.split(":");
					node = tab[0];
				}
				if (dejaDansListe(nodeList, node) == false && !node.equals("1")) {
					nodeList.add(node);
				}
				node="";
			}else{
				if(!node.equals("")){
					if(node.equals("1")){
						node=String.valueOf(ret.charAt(i));
					}else{
						node+=ret.charAt(i);
					}
				}
			}
			
		}
		
		Pattern pattern = Pattern.compile("\\((.+)\\).*-.*(Length|ST).*->.*\\((.+)\\)");
		Matcher matcher = pattern.matcher(ret);
		if (matcher.find()) {
			String node1 = matcher.group(1);
			String node3 = matcher.group(3);
			String node2 = matcher.group(2);
			if (node1.contains(":")) {
				String[] tab=node1.split(":");
				node1 = tab[0];
			}
			if (node3.contains(":")) {
				String[] tab=node3.split(":");
				node3 = tab[0];
			}
			if(node2.equals("Length")){
				lengthStr = "length_" + node1 + "_" + node3;
			}
			if(node2.equals("ST")){
				lengthStr = "strength_"+node1+"_"+node3;
			}

			
		}
		return lengthStr;
	}

	public Map<String,TrapezoidalFunction> getTrapezList() {
		/*for(Entry<String, TrapezoidalFunction> entry : trapezList.entrySet()) {
			String cle = entry.getKey();
		    TrapezoidalFunction valeur = entry.getValue();
		    System.out.println("[FUDGE DEBUG ENTRY IN TRAPEZ LSIT] "+valeur);
		}*/
		return trapezList;
	}

	public void setTrapezList(HashMap<String,TrapezoidalFunction> trapezList) {
		this.trapezList = trapezList;
	}
	
	
}
