package org.neo4j.community.console;

import java.util.Map;

public class Row implements Comparable<Row>{
    // This part has to be optimized as this contant is defined in the CypherQueryExecutor class too.
    // Of course, this value HAS TO BE THE SAME in these two classes
    static final String SAT_DEGREE_COL_NAME = "Satisfaction_degree";

    private Map<String, Object> value;
    
    public Row(Map<String, Object> valueIn){
	value = valueIn;
    }

    Map<String, Object> getValue(){
	return value;
    }

    boolean equalMaps(Map<String,Object>m1, Map<String,Object>m2) {
	if (m1.size() != m2.size())
	    return false;
	for (String key: m1.keySet())
	    if (!m1.get(key).equals(m2.get(key)))
		return false;
	return true;
    }

    public boolean equals(Object obj){
	if (obj==this) { return true; }
	if (!(obj instanceof Row)) { return false; } 
	Row obj_row = (Row) obj;
	return equalMaps(this.value,obj_row.value);
    }
    
    public int hashCode(){
	return value.get(SAT_DEGREE_COL_NAME).hashCode();
    }

    public int compareTo(Row r){
	Double sat_degree_r = (Double) r.value.get(SAT_DEGREE_COL_NAME);
	Double sat_degree_this = (Double) this.value.get(SAT_DEGREE_COL_NAME);
	return sat_degree_this.compareTo(sat_degree_r);
    }

}
