@REM ----------------------------------------------------------------------------
@REM Copyright 2001-2004 The Apache Software Foundation.
@REM
@REM Licensed under the Apache License, Version 2.0 (the "License");
@REM you may not use this file except in compliance with the License.
@REM You may obtain a copy of the License at
@REM
@REM      http://www.apache.org/licenses/LICENSE-2.0
@REM
@REM Unless required by applicable law or agreed to in writing, software
@REM distributed under the License is distributed on an "AS IS" BASIS,
@REM WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
@REM See the License for the specific language governing permissions and
@REM limitations under the License.
@REM ----------------------------------------------------------------------------
@REM

@echo off

set ERROR_CODE=0

:init
@REM Decide how to startup depending on the version of windows

@REM -- Win98ME
if NOT "%OS%"=="Windows_NT" goto Win9xArg

@REM set local scope for the variables with windows NT shell
if "%OS%"=="Windows_NT" @setlocal

@REM -- 4NT shell
if "%eval[2+2]" == "4" goto 4NTArgs

@REM -- Regular WinNT shell
set CMD_LINE_ARGS=%*
goto WinNTGetScriptDir

@REM The 4NT Shell from jp software
:4NTArgs
set CMD_LINE_ARGS=%$
goto WinNTGetScriptDir

:Win9xArg
@REM Slurp the command line arguments.  This loop allows for an unlimited number
@REM of arguments (up to the command line limit, anyway).
set CMD_LINE_ARGS=
:Win9xApp
if %1a==a goto Win9xGetScriptDir
set CMD_LINE_ARGS=%CMD_LINE_ARGS% %1
shift
goto Win9xApp

:Win9xGetScriptDir
set SAVEDIR=%CD%
%0\
cd %0\..\.. 
set BASEDIR=%CD%
cd %SAVEDIR%
set SAVE_DIR=
goto repoSetup

:WinNTGetScriptDir
set BASEDIR=%~dp0\..

:repoSetup


if "%JAVACMD%"=="" set JAVACMD=java

if "%REPO%"=="" set REPO=%BASEDIR%\repo

set CLASSPATH="%BASEDIR%"\etc;"%REPO%"\org\eclipse\jetty\jetty-server\9.0.5.v20130815\jetty-server-9.0.5.v20130815.jar;"%REPO%"\org\eclipse\jetty\orbit\javax.servlet\3.0.0.v201112011016\javax.servlet-3.0.0.v201112011016.jar;"%REPO%"\org\eclipse\jetty\jetty-http\9.0.5.v20130815\jetty-http-9.0.5.v20130815.jar;"%REPO%"\org\eclipse\jetty\jetty-util\9.0.5.v20130815\jetty-util-9.0.5.v20130815.jar;"%REPO%"\org\eclipse\jetty\jetty-io\9.0.5.v20130815\jetty-io-9.0.5.v20130815.jar;"%REPO%"\org\eclipse\jetty\jetty-webapp\9.0.5.v20130815\jetty-webapp-9.0.5.v20130815.jar;"%REPO%"\org\eclipse\jetty\jetty-xml\9.0.5.v20130815\jetty-xml-9.0.5.v20130815.jar;"%REPO%"\org\eclipse\jetty\jetty-servlet\9.0.5.v20130815\jetty-servlet-9.0.5.v20130815.jar;"%REPO%"\org\eclipse\jetty\jetty-security\9.0.5.v20130815\jetty-security-9.0.5.v20130815.jar;"%REPO%"\org\neo4j\neo4j-rest-graphdb\2.0.0\neo4j-rest-graphdb-2.0.0.jar;"%REPO%"\org\codehaus\jackson\jackson-jaxrs\1.9.7\jackson-jaxrs-1.9.7.jar;"%REPO%"\org\codehaus\jackson\jackson-core-asl\1.9.7\jackson-core-asl-1.9.7.jar;"%REPO%"\org\codehaus\jackson\jackson-mapper-asl\1.9.7\jackson-mapper-asl-1.9.7.jar;"%REPO%"\org\neo4j\neo4j-shell\2.1.1\neo4j-shell-2.1.1.jar;"%REPO%"\org\apache\servicemix\bundles\org.apache.servicemix.bundles.jline\0.9.94_1\org.apache.servicemix.bundles.jline-0.9.94_1.jar;"%REPO%"\org\neo4j\neo4j\2.1.1\neo4j-2.1.1.jar;"%REPO%"\org\neo4j\neo4j-kernel\2.1.1\neo4j-kernel-2.1.1.jar;"%REPO%"\org\neo4j\neo4j-lucene-index\2.1.1\neo4j-lucene-index-2.1.1.jar;"%REPO%"\org\apache\lucene\lucene-core\3.6.2\lucene-core-3.6.2.jar;"%REPO%"\org\neo4j\neo4j-graph-algo\2.1.1\neo4j-graph-algo-2.1.1.jar;"%REPO%"\org\neo4j\neo4j-graph-matching\2.1.1\neo4j-graph-matching-2.1.1.jar;"%REPO%"\org\neo4j\neo4j-cypher\2.1.1\neo4j-cypher-2.1.1.jar;"%REPO%"\org\neo4j\neo4j-cypher-commons\2.1.1\neo4j-cypher-commons-2.1.1.jar;"%REPO%"\org\neo4j\neo4j-cypher-compiler-1.9\2.0.1\neo4j-cypher-compiler-1.9-2.0.1.jar;"%REPO%"\org\neo4j\neo4j-cypher-compiler-2.0\2.0.1\neo4j-cypher-compiler-2.0-2.0.1.jar;"%REPO%"\org\parboiled\parboiled-scala_2.10\1.1.6\parboiled-scala_2.10-1.1.6.jar;"%REPO%"\org\parboiled\parboiled-core\1.1.6\parboiled-core-1.1.6.jar;"%REPO%"\org\neo4j\neo4j-cypher-compiler-2.1\2.1.1\neo4j-cypher-compiler-2.1-2.1.1.jar;"%REPO%"\net\sf\opencsv\opencsv\2.3\opencsv-2.3.jar;"%REPO%"\com\googlecode\concurrentlinkedhashmap\concurrentlinkedhashmap-lru\1.3.1\concurrentlinkedhashmap-lru-1.3.1.jar;"%REPO%"\org\scala-lang\scala-library\2.10.4\scala-library-2.10.4.jar;"%REPO%"\com\sun\jersey\jersey-client\1.9\jersey-client-1.9.jar;"%REPO%"\com\sun\jersey\jersey-core\1.9\jersey-core-1.9.jar;"%REPO%"\org\hamcrest\hamcrest-core\1.1\hamcrest-core-1.1.jar;"%REPO%"\org\neo4j\neo4j-geoff-core\1.7-SNAPSHOT\neo4j-geoff-core-1.7-20120413.095721-143.jar;"%REPO%"\org\neo4j\neo4j-kernel\2.1.1\neo4j-kernel-2.1.1-tests.jar;"%REPO%"\org\neo4j\neo4j-primitive-collections\2.1.1\neo4j-primitive-collections-2.1.1.jar;"%REPO%"\org\apache\geronimo\specs\geronimo-jta_1.1_spec\1.1.1\geronimo-jta_1.1_spec-1.1.1.jar;"%REPO%"\org\slf4j\slf4j-api\1.6.1\slf4j-api-1.6.1.jar;"%REPO%"\org\slf4j\slf4j-log4j12\1.6.1\slf4j-log4j12-1.6.1.jar;"%REPO%"\log4j\log4j\1.2.16\log4j-1.2.16.jar;"%REPO%"\com\sparkjava\spark-core\1.1.1\spark-core-1.1.1.jar;"%REPO%"\com\google\code\gson\gson\2.0\gson-2.0.jar;"%REPO%"\junit\junit\4.10\junit-4.10.jar;"%REPO%"\commons-httpclient\commons-httpclient\3.1\commons-httpclient-3.1.jar;"%REPO%"\commons-logging\commons-logging\1.0.4\commons-logging-1.0.4.jar;"%REPO%"\commons-codec\commons-codec\1.2\commons-codec-1.2.jar;"%REPO%"\org\neo4j\SUGAR\1.0\SUGAR-1.0.jar
set EXTRA_JVM_ARGUMENTS=-Xmx512m -Dfile.encoding=UTF-8
goto endInit

@REM Reaching here means variables are defined and arguments have been captured
:endInit

%JAVACMD% %JAVA_OPTS% %EXTRA_JVM_ARGUMENTS% -classpath %CLASSPATH_PREFIX%;%CLASSPATH% -Dapp.name="webapp" -Dapp.repo="%REPO%" -Dbasedir="%BASEDIR%" org.neo4j.community.console.Console %CMD_LINE_ARGS%
if ERRORLEVEL 1 goto error
goto end

:error
if "%OS%"=="Windows_NT" @endlocal
set ERROR_CODE=1

:end
@REM set local scope for the variables with windows NT shell
if "%OS%"=="Windows_NT" goto endNT

@REM For old DOS remove the set variables from ENV - we assume they were not set
@REM before we started - at least we don't leave any baggage around
set CMD_LINE_ARGS=
goto postExec

:endNT
@endlocal

:postExec

if "%FORCE_EXIT_ON_ERROR%" == "on" (
  if %ERROR_CODE% NEQ 0 exit %ERROR_CODE%
)

exit /B %ERROR_CODE%
